#include <stdio.h>
#include <stdlib.h>
#include <string.h>
char str[128];
int lex; 
int r,i;
void getlex(void)
{
  while(str[i]==' ') i++;
  if(str[i]==0) { lex=0; return; }
  if(strchr("[]()",str[i])!=0) { lex=str[i]; i++; return; }
  if(str[i]<'0' || str[i]>'9')
    exit(1);
  lex='0';
  r=atoi(str+i);
  while(str[i]>='0' && str[i]<='9') i++;
}
double chain(void)
{ double res=0;
  if(lex=='0') { res=r; getlex(); return res; }
  if(lex=='(') {
    getlex();
    if(lex==')') 
      exit(1);
    while(lex!=')')
    {
      res+=chain();
    }
    getlex();
    return res;
  }
  if(lex=='[') {
    getlex();
    if(lex==']') 
      exit(1);
    while(lex!=']')
    {
      res+=1/chain();
    }
    getlex();
    return 1/res;
  }
  exit(1);
  return 0;
}
int main (void)
{
  int t;
  freopen ("input.txt","r",stdin);
  freopen ("output.txt","w",stdout);
  scanf ("%d%*c",&t);
  while(t-->0)
  { i=0;
    scanf("%[^\n]%*c",str);
    getlex();
    printf("%.3lf\n",chain());
    if(lex!=0) exit(1); 
  }
  return 0;
}
